function [Data]=generate_data(P,N,T, phi)

Tp=T-1; % Tp  0,1,2,...,Tp as opposed to 1,2,...,T

% assign values from P
kpa=P.kpa;
rho=P.rho;

% assign AR(1) coef
%phi=0.8;


% error variances
sigei_b=((rand(N,1)+1)).^0.5; %
sigei_a=((rand(N,1)*0.5+0.25)).^0.5;

% errors
eps=zeros(N,T);
Th=floor(Tp/2);
eps=[((random('chi2',2,[N,Th+1])-2)/2).*(sigei_a*ones(1,Th+1)),((random('chi2',2,[N,Tp-Th])-2)/2).*(sigei_b*ones(1,Tp-Th)) ];
u=eps;

% fe
pi=randn(N,1);
for t=2:T
    alpha=pi+rho^(t-1)*u(:,t);
end

% starting values
y=zeros(N,T);
y(:,1)=alpha/(1-phi)+kpa*pi+randn(N,1);

% data
for t=2:T
    y(:,t)=alpha+phi*y(:,t-1)+u(:,t);
end

 %% assign data

Data=assign_datal(y(:,1:T),  T, phi, N);

end