%disp('Job started...')

% define working path and filenames
path=pwd; 
matlab_results_file='/expF_'; % start of the name of xls file where selected results will be stored
matlab_results_file_all='/mcresults_all'; % name of mat file where all results are stored

% experiment set-up
idex=[2,2,1,1,1,1,1,1]; % set maximum numbers for the experiment identifiers id1,...,id8

Ns=[ 100 200 500 1000 2000 4000 8000]; 
bNmax=size(Ns,2);   maxN=max(Ns);   minN=min(Ns);   % choices for N
Tp=[ 3,  4,  5,6,8,10,12,14,16,18, 20]; 
Ts=Tp+1;  bTmax=size(Tp,2);                                         % choices for T+1;
R=2000;                                                         % Number of replications (R)

ies=1;      % experiment types (set to 1)

use_saved_coef=0; % this loads previously saved w
save_by_parts=1; % 1 for saving individual experiments as soon as they are finished

% setting for power
jp=121;  % number of power experiments
jps=61; % selected index to report as size

rng(123456987);
rr=floor(rand(R,1)*(10^9));
%% experiment types
for ie=1:ies

    B=basic_setup_shortpanels(Ns, Ts, bNmax, bTmax, use_saved_coef, jp, jps, idex, R);
%% Main body of program

tic % start timer

% intialize final results fields
NoEst=9; % number of experiments/structures
Rr1=initialize_results(B);
Rr=repmat(Rr1,[1,1,1,1,1,1,1,1,1,1,NoEst]);
 
d1_start=1;
d2_start=1;
d3_start=1;
d4_start=1;
d5_start=1;
d6_start=1;
d7_start=1;
d8_start=1;


for bt=1:bTmax
    phirange=0; 
    T=Ts(bt);
    Wopt{bt}=simul_weightsNOT(T,phirange);
end

% computation of experiments
for d1=d1_start           : idex(1)
for d2=d2_start           : idex(2)
for d3=d3_start           : idex(3)   
for d4=d4_start           : idex(4) 
for d5=d5_start           : idex(5) 
for d6=d6_start           : idex(6)
for d7=d7_start           : idex(7)
for d8=d8_start           : idex(8)
    

    [S]=sel_experiment(d1,d2,d3,d4,d5,d6,d7,d8,B, use_saved_coef); % adjusts didex specific coefficients
    eid=experimentID_sp(d1,d2,d3,d4,d5,d6,d7,d8, Ns, Ts,R);
   
if  sum(eid.no==experiments)==1
    [eid.no, d1,d2,d3, d4]
    for bn=1:bNmax
        N=Ns(bn);
        P=create_coef(S,N);  % create didex and N specific coefficients

        for bt=1:bTmax
            T=Ts(bt);   strcat('N=',int2str(N), ' T=',int2str(T), ' didex=', int2str(d1),',',int2str(d2),',',int2str(d3),',',int2str(d4),',',int2str(d5),',',int2str(d6))
            Wo=Wopt{bt};
            % initialize replication-results fields
            [Re1,rer]=i_r_cycle(S);
            Re=repmat(Re1,1,NoEst);
            rpt=zeros(R,9);
            
            nData=8; % number of data structures

             parfor r=1:S.R % replication cycle (can be parfor)
                 tic
                 rng(rr(r))
                  % r
                    Res=repmat(rer,1,NoEst);
                    [Data]=generate_data(P,N,T, phi0); 

                         % AH  with all moments
                        [a, b]=do_experiment_fullAHuF(P,N,T, Data, Wo); % 1-step and 2-step AH
                        Res(1)=b; % 2-step AH

                        % AAH with all moments
                       [~, b, beta2, vb2]=do_experiment_fullAAHuF(P,N,T, Data, Wo); %1-step and 2-step AAH
                       Res(2)=b; % 2-step AAH

                     % AB moments estimators - preselectin using MT testing on d
                        [a,b]=do_experiment_ABsf(P,N,T, Data, Wo);   
                        Res(3)=a; %AB - 2step 
                        Res(8)=b; %AB-O - 2step 

                     [~, ~, ~,... %rtransML,  rGMM_DIF1_1step, rGMM_DIF1_2step,
                       ~, ~, ~, ...%rGMM_DIF1_CUE, rGMM_DIF2_1step, rGMM_DIF2_2step,
                       ~, ~, Res(4), ...% rGMM_DIF2_CUE, rGMM_SYS1_1step, rGMM_SYS1_2step,
                       ~, ~, ~, ...% rGMM_SYS1_CUE, rGMM_SYS2_1step, rGMM_SYS2_2step,
                       ~ , beta_sys1_2step, var_sys1_2step                  ] = do_experiment1(P,N,T, Data,  0); %rGMM_SYS2_CUE
                   
                         % AAH now with pre-selection
                        [a, b]=do_experiment_fullAAHu_preselectionOCMT(P,N,T, Data, Wo);
                        Res(5)=b;

                     % Ave_AAH  
                       [~,b, ~ ]=do_experiment_AAHaveT(P,N,T, Data, Wo);
                       Res(6)=b;
                    
                    % now Hausman test 
                        [Res(7), H]=Hausman_mc( beta2, vb2, beta_sys1_2step, var_sys1_2step, P  );
                    Re(r,:)=Res;
                  if mod(r,200)==0
                      toc
                  end
            end % r - repetition cycle

            %% collect individual test results
            for est=1:NoEst
                    Rr(d1,d2,d3,d4,d5,d6,d7,d8,bn,bt,est)=collect_partial(Re(:,est), S);
            end
     

         end %2bt - T cycle
    end % bn - N cyle
% save individual experiments
  
clear Re; % to save space

  if save_by_parts==1
        eid=experimentID_sp(d1,d2,d3,d4,d5,d6,d7,d8, Ns, Ts,R);
        strcat('saving exp. no. ',int2str(eid.no))
            ext=['phi',int2str(phi0*10),'_'];
        file_saveM=strcat(path,matlab_results_file,ext,int2str(eid.no),'.mat');
        save(file_saveM);
  end
  toc
  tic
end %if eid.no 
  
end %d8
end %d7
end %d6
end %d5
end %d4
end %d3
end %d2
end %d1
toc


end % ie
